//+------------------------------------------------------------------+
//|                                                 TrendMACD v6.mq4 |
//|Analyzing the MACD histogram for the last three bars       Genkov |
//|                     for trading                     genkov@bk.ru |
//+------------------------------------------------------------------+
#property copyright "Genkov"
#property link      "genkov@bk.ru"
//if you comment on the below string, 
//the properties window will not be displayed
//#property show_inputs   
extern int a = 1; // here you can specify any initial bar to be researched
extern int period = 30;       // enter the value of the timeframe you need
//+------------------------------------------------------------------+
int start()
  {
   int Message = 1;
   int b,c; b=a+1; c=b+1;
//----
  double Macd_h1_a= iMACD(NULL,period,12,26,9,PRICE_CLOSE,MODE_MAIN,a);
  double Macd_h1_b= iMACD(NULL,period,12,26,9,PRICE_CLOSE,MODE_MAIN,b);
  double Macd_h1_c= iMACD(NULL,period,12,26,9,PRICE_CLOSE,MODE_MAIN,c);
  
  // to make the calculations control visible, you can view 
  // these results by enabling the 'Print' operator.
  // Print("   Macd_h1_c= ",Macd_h1_c*10,"   Macd_h1_b*10= ",
  //           Macd_h1_b*10,"   Macd_h1_a= ",Macd_h1_a*10);
  if ( Message == 1 )
   {        
// ----------------------for MACD below the axis-------------------------1--&
  if(Macd_h1_c<0.0&&Macd_h1_a<0.0&&Macd_h1_a<0.0) 
   {
     //increment of bar "0" as related to bar "1"
     double r1=MathAbs(MathAbs(Macd_h1_a)-MathAbs(Macd_h1_b));
     //increment of bar "1" as related to bar "2" 
     double r2=MathAbs(MathAbs(Macd_h1_b)-MathAbs(Macd_h1_c));
// -- MACD is at the bottom - the trend is moving down
   if(Macd_h1_c>Macd_h1_b&&Macd_h1_b>Macd_h1_a)
    {
     if(r1>r2) 
     {
     Alert("On ",a," bar, MACD<0 = ",Macd_h1_a,
           "  The trend is moving down \\\'with acceleration");
     }
    if(r1<r2) 
     {
     Alert("On ",a," bar, MACD<0 = ",Macd_h1_a,
           "  The trend is moving down \^with deceleration");
     }
    if((r1==r2)||MathAbs(r1-r2)<0.000015)
     {
     Alert("On ",a," bar, MACD<0 = ",Macd_h1_a,
           "  The trend is moving down uniformly accelerated");
     }
    }
// -- MACD is at the bottom - the trend is moving up
   if(Macd_h1_c<Macd_h1_b&&Macd_h1_b<Macd_h1_a)
    {
    if(r1>r2) 
     {
     Alert("On ",a," bar, MACD<0 =",Macd_h1_a,
           "  The trend is moving up //''with acceleration");
     }
    if(r1<r2) 
     {
     Alert("On ",a," bar, MACD<0 = ",Macd_h1_a,
           "  The trend is moving up /^with deceleration");
     }
    if((r1==r2)||MathAbs(r1-r2)<0.000015)
     {
     Alert("On ",a," bar, MACD<0 = ",Macd_h1_a,
           "  The trend is moving up uniformly accelerated");
     }
    }
// --- MACD is at the bottom - the trend is reversing down    
   if(Macd_h1_c<Macd_h1_b&&Macd_h1_b>Macd_h1_a)
    {
    if(r1>r2) 
     {
     Alert("On ",a," bar, MACD<0 = ",Macd_h1_a,
           "  The trend is reversing down /\\'with acceleration");
     }
    if(r1<r2)
     {
     Alert("On ",a," bar, MACD<0 = ",Macd_h1_a,
           "  The trend is reversing down //^with deceleration");
     }
    }
// --- MACD is at the bottom - the trend is reversing up
   if(Macd_h1_c>Macd_h1_b&&Macd_h1_b<Macd_h1_a)
    {
    if(r1>r2)
     {
     Alert("On ",a," bar, MACD<0 = ",Macd_h1_a,
           "  The trend is reversing up //''with acceleration");
     }
     if(r1<r2) 
     {
     Alert("On ",a," bar, MACD<0 = ",Macd_h1_a,
           "  The trend is reversing up \/^with deceleration");
     }
    }
   if(MathAbs(MathAbs(Macd_h1_a)-MathAbs(Macd_h1_b))<0.0002 && 
      MathAbs(MathAbs(Macd_h1_c)-MathAbs(Macd_h1_b))<0.0002)
    {
    Alert("On ",a," bar,it is Flat! ranging within:  ",Macd_h1_c,
          "   ",Macd_h1_b,"   ",Macd_h1_a);
    }
   }
// -------------------for MACD above the axis----------------------------2--&    
  if(Macd_h1_c>0.0 && Macd_h1_b>0.0 && Macd_h1_a>0.0)   
   {
    {
     r1=MathAbs(MathAbs(Macd_h1_a)-MathAbs(Macd_h1_b));
     r2=MathAbs(MathAbs(Macd_h1_c)-MathAbs(Macd_h1_b));
// MACD is above the axis - the trend is moving up     
    if(Macd_h1_c<Macd_h1_b&&Macd_h1_b<Macd_h1_a&&(r1>r2))
     {
     Alert("On ",a," bar, MACD >0 = ",Macd_h1_a,
           "  The trend is moving up //''with acceleration");
     }
    if(Macd_h1_c<Macd_h1_b&&Macd_h1_b<Macd_h1_a&&(r1<r2))
     {
     Alert("On ",a," bar, MACD >'0'= ",Macd_h1_a,
           "  The trend is moving up /^with deceleration");
     }
    if(Macd_h1_c<Macd_h1_b&&Macd_h1_b<Macd_h1_a)
     {
    if((r1==r2)||MathAbs(r2-r1)<0.000015)
     {
     Alert("On ",a," bar, MACD >'0' = ",Macd_h1_a,
           "  The trend is moving up uniformly accelerated");
     }
    }
   }
// MACD is above the axis - the trend is moving down
  if(Macd_h1_c>Macd_h1_b&&Macd_h1_b>Macd_h1_a)
   {
    if((r1==r2)||MathAbs(r1-r2)<0.000015)
     {
     Alert("On ",a," bar, MACD > 0 = ",Macd_h1_a,
           " The trend is moving down uniformly accelerated");    
     }
   if(r1>r2)
     {
     Alert("On ",a," bar, MACD > 0 = ",Macd_h1_a,
           "  The trend is moving down \\\'with acceleration");  
     }
     if(r1<r2) 
     {
     Alert("On ",a," bar, MACD > 0 = ",Macd_h1_a,
           "  The trend is moving down \\^with deceleration"); 
     } 
    }
// MACD is above the axis -  the trend is reversing down
   if(Macd_h1_c<Macd_h1_b&&Macd_h1_b>Macd_h1_a)
    {
    if(r1>r2) 
     {
     Alert("On ",a," bar, MACD > 0 = ",Macd_h1_b,
           "  The trend isreversing down \\' with acceleration");
            
     }
    if(r1<r2) 
     {
     Alert("On ",a," bar, MACD > 0 = ",Macd_h1_b,"  Trend ",
           " is reversing down \\^ with deceleration"); 
     }
    }
// MACD is above the axis -  the trend is reversing up
  if(Macd_h1_c>Macd_h1_b&&Macd_h1_b<Macd_h1_a)
    {
    if(r1>r2) 
     {
     Alert("On ",a," bar, MACD > 0 ",Macd_h1_b,"  Trend",
           " is reversing up //'' with acceleration"); 
     }
    if(r1<r2) 
     {
     Alert("On ",a," bar, MACD  > 0 ",Macd_h1_b,"  Trend",
           " is reversing up //'' with deceleration");
     }
    }
    if(MathAbs(MathAbs(Macd_h1_a)-MathAbs(Macd_h1_b))<0.0002 &&
       MathAbs(MathAbs(Macd_h1_b)-MathAbs(Macd_h1_c))<0.0002)     
    {
    Alert("On ",a," bar, it is Flat! ranging within:  ",Macd_h1_c, 
          "   ",Macd_h1_b,"   ",Macd_h1_a);
    }
   }
// ------------for crossing the axis from bottom to top------------------3--&
   if(Macd_h1_c<0.0 && Macd_h1_b<0.0 && Macd_h1_a>0&&  // c<0 b<0
      Macd_h1_c<Macd_h1_b&&Macd_h1_b<Macd_h1_a)  
    {
     r1=MathAbs(Macd_h1_a)+MathAbs(Macd_h1_b);
     r2=MathAbs(Macd_h1_c)-MathAbs(Macd_h1_b);
    if(MathAbs(r1)>MathAbs(r2))
     {
     Alert("On ",a," bar, Trend is crossing the axis from bottom to top //'' with acceleration ");
     }
    if(MathAbs(r1)<MathAbs(r2))
     {
     Alert("On ",a," bar, Trend is crossing the axis from bottom to top /^ with deceleration ");
     }
    }
//---     
   if(Macd_h1_c<0.0 && Macd_h1_b>0.0 && Macd_h1_a>0&&  // b>0 a>0
      Macd_h1_c<Macd_h1_b&&Macd_h1_b<Macd_h1_a)
    {
     r1=MathAbs(Macd_h1_a)-MathAbs(Macd_h1_b);
     r2=MathAbs(Macd_h1_c)+MathAbs(Macd_h1_b);
    if(MathAbs(r1)>MathAbs(r2))
     {
     Alert("On ",a," bar, Trend is crossing the axis from bottom to top //''with acceleration");
     }
    if(MathAbs(r1)<MathAbs(r2))
     {
     Alert("On ",a," bar, Trend is crossing the axis from bottom to top /^ with deceleration");
     }
    }
// -------------for crossing the axis from top to bottom  ---------------4--&
    if(Macd_h1_c>0 && Macd_h1_b>0 && Macd_h1_a<0&&   // c>0 b>0
       Macd_h1_c>Macd_h1_b&&Macd_h1_b>Macd_h1_a) 
     {
      r1=MathAbs(Macd_h1_a)+MathAbs(Macd_h1_b);
      r2=MathAbs(Macd_h1_c)-MathAbs(Macd_h1_b);
   //--   
     if(MathAbs(r1)>MathAbs(r2))
      { 
      Alert("On ",a," bar, Trend is crossing the axis from top to bottom \\\' with acceleration");
      }
   //--   
     if(MathAbs(r1)<MathAbs(r2))
      { 
      Alert("On ",a," bar, Trend is crossing the axis from top to bottom \\^ with deceleration");
      }
     }
 //-----    
     if(Macd_h1_c>0 && Macd_h1_b<0 && Macd_h1_a<0&&   // b<0 a<0
        Macd_h1_c>Macd_h1_b&&Macd_h1_b>Macd_h1_a) 
     {
      r1=MathAbs(Macd_h1_a)-MathAbs(Macd_h1_b);
      r2=MathAbs(Macd_h1_c)+MathAbs(Macd_h1_b);
   //--      
     if(MathAbs(r1)>MathAbs(r2))
      { 
      Alert("On ",a," bar, Trend is crossing the axis from top to bottom \\\' with acceleration");
      }
   //--      
     if(MathAbs(r1)<MathAbs(r2))
      { 
      Alert("On ",a," bar, Trend is crossing the axis from top to bottom \\^ with deceleration");
      }
     }
// -----  if MACD of bar "1" = "0"    
     if(Macd_h1_c>0&&Macd_h1_b==0&&Macd_h1_a<0&&
        Macd_h1_c>Macd_h1_b&&Macd_h1_b>Macd_h1_a)
      {
       r1=MathAbs(Macd_h1_a);
       r2=MathAbs(Macd_h1_c);       
      if(MathAbs(r1)>MathAbs(r2))
       {   
       Alert("On  ",a," bar, Trend is crossing the axis from top to bottom \\\' with acceleration" ); 
       }
      if(MathAbs(r1)<MathAbs(r2))
       {   
       Alert("On ",a," bar, Trend is crossing the axis from top to bottom \\^ with deceleration_" ); 
       }
      if(MathAbs(r1)==MathAbs(r2)) // rare coincidence! 
      {   
       Alert("On ",a," bar, Trend is crossing the axis from top to bottom uniformly accelerated" );
       } 
     }
// ----------------------------------------------------------------5--&
}
   return(0);
  }
//--end---------------------------------------------------------------+